package org.example;

import org.pavlik.bot.*;
import org.pavlik.helpers.CoreHelp;
import org.pavlik.helpers.Morph;

import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.Deque;

import java.util.HashMap;
import java.util.Properties;




public class App 
{
    protected static String tgToken;
    protected static TelegramAdapter tgAdapter;
    public static boolean stop_signal=false;
    public static BotDialogController botDialogController = null;
    public static BotCommands botCommands = null;
    public static String admin_chat;
    public static HashMap<String, BotDialog> Dialogs = new HashMap<>();

    public static void loadConf() {

        File file = new File("settings.properties");
        Properties properties = new Properties();
        try {
            properties.load(new FileReader(file));
        } catch (IOException e) {
            System.out.println("файл с настройками не грузанулся");
            throw new RuntimeException(e);
        }

        tgToken = properties.getProperty("tg.token");
        admin_chat = properties.getProperty("tg.admin_id");

        System.out.println("tgTokenLoaded");
    }


    public static void printStat() {
        Runtime runtime = Runtime.getRuntime();
        long totalMemory = runtime.totalMemory();
        long freeMemory = runtime.freeMemory();
        long usedMemory = totalMemory - freeMemory;



        System.out.println("Total memory: " + totalMemory);
        System.out.println("Free memory: " + freeMemory);
        System.out.println("Used memory: " + usedMemory);

        //String path = System.getProperty("user.dir");
    }

    public static void initApp() {
        loadConf();
        App.botDialogController = new BotDialogController();
        App.botCommands = new BotCommands();
        tgAdapter = new TelegramAdapter(tgToken);
        startMsg();
    }


    //сообщение о запуске админу
    public static void startMsg(){
        String res = null;

        while (res==null) {
            CoreHelp.sleep(5000);

            res = tgAdapter.sendMessage(admin_chat,"Я родился!");
        }
    }




    /**
     * Вытащить в асинхрон заполнение очереди и разгребание
     *
     * @param args
     */
    public static void main( String[] args )
    {
        initApp();


        while (!stop_signal) {

            Long offset = tgAdapter.last_update + 1;
            Deque<MessageObj> out = tgAdapter.getUpdates(offset.toString());

            //если проблемы с соединением, то поспать 5 секунд и повторить...
            if (out==null) {
                System.out.println("result error");

                CoreHelp.sleep(5000);

                continue;
            }

            if (out.size()>0) {
                while(!out.isEmpty()) {

                    MessageObj r = out.pop();
                    if (r.message_id.isEmpty()) continue;


                    if (!Dialogs.containsKey(r.message_id)) {
                        Dialogs.put(r.message_id, new BotDialog(tgAdapter));
                    }

                    App.botDialogController.answer(Dialogs.get(r.message_id),r);

                }
            }

        }




    }


}
