package org.pavlik.bot;

import org.example.App;


public class BotDialogController {



    public void answer(BotDialog dialog, MessageObj r)
    {
        dialog.is_admin = checkAdmin(r);
        String response = genResponse(r,dialog);

        if (response!=null && !response.isEmpty() && !r.message_id.isEmpty()) {
            dialog.adapter.sendMessage(r.message_id, response);
        }

    }


    /**
     * Генерация ответа на сообщение
     * @param r - request, объект входящего сообщения с данными о пользователе, об объектах в сообщении
     * @param dialog - контекст диалога с конкретным собеседником
     * @return - текстовая строка с ответом на сообщение
     */
    protected String genResponse(MessageObj r, BotDialog dialog) {
        if (r.text == null) {
            return "Ты шлешь мне какую-то дичь, еще раз пришлешь, не буду с тобой разговаривать.";
        }

        if (!r.text.isEmpty()) {
            if (r.is_command || dialog.lastCmd!=null) {
                //обработчик команд
                return App.botCommands.runCmd(dialog,r);
            }
            else {
                return govorilka(r,dialog);
            }
        }

        return "";

    }


    protected String govorilka(MessageObj r, BotDialog dialog) {
        if (!dialog.zdorova) {
            dialog.zdorova = true;
            return "Здарова, давай поговорим, скажи как к тебе обращаться?";
        }
        if (!dialog.answName) {
            dialog.answName = true;
            dialog.userName = r.text;
            return "Хорошо, "+dialog.userName+", так и буду тебя называть!!!";
        }

        return dialog.userName+", на твое сообщение <"+r.text+"> я пока ответов не знаю, я маленький и глупый...";
    }


    protected boolean checkAdmin(MessageObj r) {
        return r.message_id.equals("1187023222") && r.user_id.equals("pavelbbb");
    }



}
