package org.pavlik.bot;

//import java.math.BigInteger;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.nio.charset.StandardCharsets;
import java.util.ArrayDeque;
import java.util.Deque;

import org.json.*;
import org.pavlik.helpers.RestHelper;


public class TelegramAdapter implements MessageAdapter {
    String token;
    RestHelper Rest;
    public Long last_update = 0l;
    protected String qUrl;

    /**
     * добавить исключение при пустом токене
     * @param token
     */
    public TelegramAdapter(String token) {
        this.token = token;
        this.Rest = new RestHelper();
        qUrl = "https://api.telegram.org/bot"+token;
    }

    @Override
    public String sendMessage(String chatId, String text) {


        String encodedMsg = null;
        try {
            encodedMsg = URLEncoder.encode(text, StandardCharsets.UTF_8.toString());
        } catch (UnsupportedEncodingException e) {
            throw new RuntimeException(e);
        }

        String queryUrl  = qUrl+"/sendMessage?chat_id="+chatId+"&text="+encodedMsg;
        String respBody = Rest.queryGetBody(queryUrl);

        System.out.println("--------------------------\n send message("+chatId+"):\n"+text);

        return respBody;

    }

    /**
     * добавить маскирование токена
     * @param offset
     * @return
     */
    @Override
    public Deque<MessageObj> getUpdates(String offset) {
        String queryUrl  = qUrl+"/getUpdates?offset="+offset+"&limit=10&timeout=60";

        String respBody = Rest.queryGetBody(queryUrl);
        System.out.println("-----------------------------------------");
        System.out.println(respBody);
        System.out.println("-----------------------------------------");

        if (respBody == null) return null;

        return parseResp(respBody);

    }

    protected Deque parseResp(String jsonBody) {
        JSONObject obj = new JSONObject(jsonBody);

        Deque<MessageObj> list = new ArrayDeque<>();

        if (obj.getBoolean("ok")) {

           JSONArray res_obj = obj.getJSONArray("result");
            for (int i = 0; i < res_obj.length(); i++) {
                JSONObject curr = res_obj.getJSONObject(i);
                MessageObj r = new MessageObj();

                Long update_id = curr.getLong("update_id");
                last_update = update_id;

                if (!curr.has("message")) continue;


                JSONObject message = curr.getJSONObject("message");
                JSONObject from = message.getJSONObject("from");
                String chat_id = from.getBigInteger("id").toString();
                if (message.has("text")) {
                    r.text = message.getString("text");
                }


                if (from.has("username"))
                r.user_id = from.getString("username");

                //detect command
                if (message.has("entities")) {
                    JSONArray entities  = message.getJSONArray("entities");
                    for (int e=0;e<entities.length();e++) {
                       JSONObject entities_it = entities.getJSONObject(e);
                       if (entities_it.has("type") && entities_it.getString("type").equals("bot_command")) {
                           r.is_command=true;
                           System.out.println("bottt!");
                       }
                    }
                }




                r.message_id = chat_id;
                r.update_id = update_id;

                
                //r.text = text;
                list.add(r);


            }
        }

        return list;

    }
}


